import customsprites
import display
import terrain
from helper import *

class Projectile:
	def __init__(self, target):
		self.target = target
		self.sprite.dest = display.get_screen().tile_to_screen(self.target.position)
		self.sprite.proj = self
	
	def set_position(self, t_pos):
		self.position = tup2rect(t_pos)
		self.sprite.set_location(display.get_screen().tile_to_screen(t_pos))
	
	def update(self, tick):
		self.sprite.dest = display.get_screen().tile_to_screen(self.target.position)

	def impact(self):
		display.get_map().del_projectile(self)

class Fireball(Projectile):
	def __init__(self, target, el):
		self.attack = 5
		self.sprite = customsprites.ProjectileSprite('Fireball', el)
		Projectile.__init__(self, target)
	
	def impact(self):
		if self.target.damage < self.target.vitality and self.target.damage >= 0:
			self.target.damage += self.attack
		Projectile.impact(self)


